#ifndef __QTGLVIEWER_H
#define __QTGLVIEWER_H

#include <QtOpenGL>
#include <QWaitCondition>

namespace GtpVisibilityPreprocessor {

class QtGlRendererWidget;


class __declspec(dllexport) QtGlViewer: public QGLWidget
{	
	//Q_OBJECT

public:
	
	QtGlViewer(QWidget *parent, QtGlRendererWidget *renderer);

	virtual ~QtGlViewer() {};

	QSize minimumSizeHint() const;
	QSize sizeHint() const;

	// This method has to be rendefined by all renderer implementations
	virtual void RenderScene();

	QtGlRendererWidget *mRenderer;

protected:

	void initializeGL();
	void paintGL();
	void resizeGL(int width, int height);
	void mousePressEvent(QMouseEvent *event);
	void mouseMoveEvent(QMouseEvent *event);

	void keyPressEvent ( QKeyEvent * e );

	bool mWireframe;

private:

	float manipulatorLastQuat[4];
	float scale;
	
	QPoint lastPos;

	friend class QtGlRendererWidget;
	friend class GlRenderer;
};

}

#endif
